-----------------------------------------------------------------------


                               Motif 2.3.8

                              Release Notes

                             The Open Group
                                   and
                     Integrated Computer Solutions


This document provides Release Notes for the release of Motif 2.3.8.

This contains information on what is new in Motif 2.3.8. 
Please see the COPYING file included with this release.


Introduction

This document and accompanying text files contain important information. 
Please read them carefully before starting the build and
installation procedures.

There are two ways to build Motif from source code: Imake and AutoTools.

If you are using Imake, please read INSTALL.imake for notes on how to build
and install this product using Imake. This method is deprecated due to
a lack of support. Users wishing to apply/test and patch the Imake system
should join the development mailing list; all contributions are welcome.

Please see the file INSTALL.configure on how to build and install this product
using the autoconf tools. This method is now fully supported and 
is the recommended build method.


1. What is Motif

Motif is a freely available source code distribution for the 
Motif user interface component toolkit. Motif is built on top of the 
standard X Toolkit(Xt) and X11 libraries.

1.1. Overview of Motif

Motif 2.3.X is an updated version of Motif 2.3. 
Any applications built against a previous 2.x release of Motif will be 
binary compatible with this release.

Pre-compiled versions are available for download at the ICS MotifZone:

http://motif.ics.com

After downloading this source distribution, it will need to be unpacked 
and compiled. The distribution contains the following items:

* libXm source code and include files
* Motif reference documentation (man pages)
* Utility libraries
* Demo programs


2. What is new in Motif 2.3.8

This is a bug fix release.

* Fixed bug 1660: TextField leaves a residual cursor shadow on focus lose
* Fixed bug 1659: Many cases of typos in horizontal/vertical conditions in the code
* Fixed bug 1658: motif does crash on OpenSuse Leap 42.2
* Fixed bug 1656: TabStack with tabSelectColor and Right causes BadMatch Error
* Fixed bug 1625: Open Motif build fails due to weak aliases on Darwin with cl
* Fixed bug 1655: Motif 2.3.6 and 2.3.4 do not work with XQuartz 2.7.9 and later
* Fixed bug 1652: Add support for more Cyrillic locales
* Fixed bug 1650: Memory leak in DataF.c
* Fixed bug 1651: motif-2.3.5 tarball contains lib/Xm/Xm.h file generated by configure
* Fixed bug 1665: Closing open menus with mouse click disables keyboard shortcut


3. Build Systems

Motif 2.3.x was built and tested on the following systems:
* Fedora 15 x86_64
* Solaris 10 sparc

In all cases, the compiler originally provided with the OS was used.

3.1. OS Support

The following platforms are supported operating systems:

* Linux 2.6
* Solaris 10

4. Filing Bug Reports

If you find a reproducible bug in any of the Motif libraries or code, 
or an error in the documentation, please reference the BUGREPORT file 
and/or submit a bug report online at:

http://bugs.motifzone.org

The status of submitted bugs is maintained there.


5. Documentation

For postscript and PDF documentation (users guides and reference 
manuals), see the URL:

http://www.opengroup.org/openmotif/docs/


6. Compatibility Notice

Motif 2.3.x is binary compatible with Motif 2.2.x. 
Applications built against Motif 2.2 should work with Motif 2.3.x 
without having to recompile it.

Motif 2.3.x is not binary compatible with Motif 2.1.30.
Applications built against Motif 2.1.30 will need to be recompiled 
with the Motif 2.2+ header files.


7. Change Log

2.3.8 December 2017
Current release

2.3.7 March 2017
* Fixed segmentation faults associated with option menus or other popup windows

2.3.6 June 2016
* Fixed bug 1654 (Rendering issues seen while scrolling window)
* Fixed parallel building error

2.3.5 March 2016
* Reimplemented bugfix 1565 (The active window changes to inactive when the drop down list is clicked)
* Fixed bug 1636 (XmList segfault when left-shift left-button click on list item)
* Fixed bug #1612 (Label size computed wrong within a Form)
* Fixed bug #1611 (Using deprecated X functions)
* Fixed bug #1604 (Using deprecated X functions)
* Fixed bug #1581 (Buffer overrun in FontS.c)
* Fixed many compile-time bugs

2.3.4 October 2012
* Fixed bug #1565 (The active window changes to inactive when the drop down
  list is clicked)
* Implemented feature request #1300 (Keypad arrows don't work)
* Fixed bug #1496 (Version 2.3.2 won't compile if configured 
  enable-message-catalog)
* Dropped fix #1359 (File dialog filter problem with * or [ in directory)
* Fixed bug #1530 (SimpleSpinBox doesn't return correct values for child on 
  some platforms)
* Fixed bug #1272 (Application goes into infinite loop in TraversalI.c:Sort())
* Fixed bug #1529 (Copy/paste problem with Clipboard)
* Fixed bug #1536 (Performance issue: XmListSetPos() is very very slow)
* Fixed bug #1501 (XmText widget sensitive/unsensitive is visibly same 
  at startup)
* Refixed bug #1381 (Sensitivity invisible with antialiased fonts)
* Fixed bug #1510 (Input methods do not work with XFT fonts)
* Fixed bug #1500 (XmPushButton with grayscale pixmap is not changed visibly 
  when it's sensitivity is changed)
* Fixed bug #1540 (XpmCreateBufferFromPixmap function doesn't work properly)
* Fixed bug #1505 (Some problems with new insensitive code for label pixmaps)
* Fixed bug #1534 (im_widget double-free issue)
* Fixed bug #1535 (Destroying a torn-off menu with a submenu mapped causes 
  a crash)
* Fixed bug #1532 (Incorrect handling of clip areas for a string (XmString.c))
* Fixed bug #1531 (Using DataField widget with XFT font causes an X Error)
* Fixed bug #1519 (XmSpinBoxValidatePosition does not properly check 
  XmNincrementValue)
* Added missing #ifdef USE_XFT directive to the patch #1521
* Fixed bug #1488 (XmStringDraw clip not honored)
* Fixed bug #1479 (Compiling libUil fails on mac OS X 10.5)
* Fixed bug #1528 (Scale widget has some Geometry issues)
* Fixed bug #1518 (gcc check in configure script does not use $CC)
* Fixed misspellings in the manpage
* Fixed bug #1504 (Changing sensitivity on a PushButton with Pixmap 
  causes recomputeSize)
* Fixed bug #1516 (Can receive X error setting pixmaps to
  XmUNSPECIFIED_PIXMAP on PushButton)
* Fixed bug #1503 (XmNtabBackground resource is not working properly 
  in XmTabStack widget)
* Fixed bug #1512 (Small configure portability fix)
* Fixed bug #1523 (Check a return value of XmCvtXmStringToCT before 
  use in strlen)
* Refixed bug #1473 (When we set XmNvisibleItemCount resource available in 
  XmComboBox, the widget displays the wrong number of items)
* Fixed bug #1521 (LabelGadget draws the text over border of its parent)
* Fixed in order to provide compatibility with libpng14, backwards 
  compatible with libpng12
* Fixed dependencies in order to allow build with "make -j" 
* Fixed bug #1509 (background pixmap not fully displayed)
* Fixed bug #1517 (LabelGadget draws over parent window with 
  the background color)
* Fixed bug #1507 (LDFLAGS not respected for building libXm 
  and libMrm libraries)
* Fixed bug #1511 (CheckBook program from EditTable samples crashes 
  with Motif since 2.3.0 release.)
* Fixed bug #1495 (mwm's icon box has graphics corruption)
* Fixed in order to provide PRINTING_SUPPORTED and USE_XFT 
  macro definitions in Xm.h
* Fixed in order to allow build without libXp
* Refixed bug #1321 (Pasting into XmTextField is unreliable)
* Fixed bug #1502 (crash in ToolTipGetData())
* Removed xmPanedWindowWidgetClass definition
* Fixed bug #1474 (Incrementation of XmNvisibleItemCount value does not work
  properly in XmComboBox)

2.3.3 March 2010 
* Fixed bug #1195 (Making on FreeBSD with non GNU make)   
* Refixed bug #1388 (SEGV error moving mouse over window related
  to XmToolTipGetLabel)
* Fixed bug #1489 (Paned.h is not included by XmAll.h)  
* Fixed bug #1486 (Tooltip in DropDown widget makes X hang up)  
* Dropped fix #1476 (PanedWindow orientation error)  
* Fixed bug #1320 (Resizing a scrolled text widget can be very, very slow)  
* Fixed bug #1449 (Uninitalised memory access with XFT fonts)  
* Fixed bug #1418 (Add file with instructions how to build from CVS)  
* Refixed bug #1381 (Sensitivity invisible with antialiased fonts)
* Fixed bug #1484 (Warning on XmRlabelType when I put a pixmap 
  and a value "top" on XmNPixmapPlacement)
* Fixed bug #1475 (autoconf warning "X11/Xmu/Editres.h header present
  but cannot be compiled")
* Fixed bug #1426 (Make location of system.mwmrc configurable)
* Fixed bug #1451 (XmStringDrawImage works incorrectly with XFT)
* Fixed bug #1453 (MultiList not displayed properly)
* Fixed bug #1412 (An insensitive popup menu parent lead to a display-freezing)
* Fixed bug #345 (Motif accelerators XmNaccelerator do not work 
  with CapsLock/ScrollLock/NumLock modifiers)
* Added splint checking and splint target
* Fixed bug #1299 (XmForm erroneously finds "Circular dependency"
  if widgets are inter-attachmed in vertical/horizontal directions)

2.3.2 March 2009 
* Fixed bug #1473 (When we set XmNvisibleItemCount resource available in 
  XmComboBox, the widget displays the wrong number of items)
* Added missing 'O' character to UTF8_SUPPORTED macro 
* Fixed bug #1476 (PanedWindow orientation error)
* Fixed bug #1277 (paned widget does not work under Fedora Core 2 
  with motif 2.2.3-4.1)
* Fixed bug #1212 (XmDropSiteRetrieve frees XRectangles before
  caller can use them)
* Fixed in order to allow build out of source tree
* Added wml_DEPENDENCIES in tools/wml/Makefile.am
* Added ACLOCAL_AMFLAGS in Makefile.am

2.3.1 September 2008 
* Added ${prefix}/share/Xm as possible prefix for demos binaries installation
* Fixed bug #1443 (Build failure on FreeBSD: undefined reference to
  `libiconv_open')
* Fixed bug #1427 (_xrm '*.iconPixmap:SDtErrors.l' produces bogus
  error messages)
* Refixed bug #1381 (Sensitivity invisible with antialiased fonts)
* Fixed bug #1359 (File dialog filter problem with * or [ in directory)
* Fixed bug #1446 (Arrow button in DropDown widget issue.)
* Fixed bug #1328 (Desktop hang: motif application in XGrabPointer)
* Fixed bug #1425 (Resetting entryParent causes crash)
* Fixed bug #1439 (warnings during compilation in TabBox.c)
* Fixed bug #1420 (DataF.c holds message strings.)
* Fixed bug #1419 (Bindings of DataField defined in DataF.c instead
  of TranslNew.c)
* Fixed bug #1431 (motif 2.3 and xorg 7.1.0 64bit problems)
* Fixed bug #1432 (XmContainer incorrect GC allocation)
* Fixed bug #1250 (XmCombo glyph is unexpectedly shifted
  when setting XmNvisibleItemCount)
* Fixed bug #1401 (Specifying state pixmaps in Container causes crash)
* Refixed bug #1442 (Crash on Drag'n'Drop)
* Fixed bug #1445 (PopupShell is closing  on MouseWheel)
* Refixed bug #1371 (XmComboBox problem on FC6)
* Fixed bug #1438 (Missing XSetErrorHandler call in XmXftDrawCreate)
* Fixed bug #1444 (Function _XmXftDrawCreate() does not work correct 
  with the pixmap)
* Fixed bug #1434 (single character utf8 sting is not displayed)
* Fixed bug #1442 (Crash on Drag'n'Drop)
* Fixed bug #1436 (Definition of GetSameRenditions in XmRenderT.c 
  needs USE_XFT conditional)
* Fixed bug #1400 (Corrupted per-display font cache)
* Fixed bug #1440 (Tags array size in Label widget is not enough)
* Fixed bug #1429 (Build failure with libtool-2.2.4)

2.3.1 Beta 1 May 2008 
* Fixed bug #1410 (setting XmNisHomogeneous to True without setting 
  XmNentryClass causes sigfault)
* Fixed bug #1402 (Toggle button circular buttons can not mimic modern look)
* Fixed bug #1415 (XFT width calculation problem)
* Fixed bug #1362 (Repeated calls to XmListReplaceItemsPos 
  cause Error: Cannot perform malloc when using Extended_Select)
* Fixed bug #1365 (Top pixel of German character I with top '^' leaves trails)
* Fixed bug #1414 (XFT support slowness)
* Fixed bug #1351 (Bad dynamic propagation of the sensitive state 
  to popup menus)
* Fixed bug #1409 (XmTextField sometimes crashes if a string is set 
  by XtSetValues when XmNmodifyVerifyCallback is set (Only in multibyte locale))
* Fixed bug #1398 (newline not supported in UTF-8 mode)
* Fixed bug #1406 (Insensitive icon on XmPushButton black instead of grayed out)
* Fixed bug #1396 (ScrollBar warning when XmNotebook resized)
* Refixed bug #1388 (SEGV error moving mouse over window 
  related to XmToolTipGetLabel).
* Fixed bug #1405 (Menus too short if PIXMAP_AND_STRING is used in PushButtons)
* Fixed bug #1404 (PIXMAP_AND_STRING causes crash 
  in XmPushButtton in OptionMenu)
* Fixed incorrect parenthesis in if statement
* Fixed bug #1371 (XmComboBox problem on FC6)
* Fixed bug #1296 (Drag-and-drop behaves incorrectly 
  if XtSetLanguageProc() is present)
* Fixed bug #1399 (cut and copy don't work in XmText widget)
* Added /usr as possible prefix for toolkit installation
* Fixed bug #1395 (Wrong label foreground for etched in menus)
* Fixed bug #1392 (The label widgets can have their core class 
  translations changed).
* Fixed bug #1337 (XmPushButton's ArmAndActivate() has incorrect callback call).
* Fixed bug #1384 (Use of freed storage in XmContainer).
* Fixed bug #1209 (XmTextPaste crashes using XmTextField).
* Fixed bug #1367 (XmText autoShowCursorPosition is not always honoured 
  when selected text is deleted).
* Fixed bug #1140 (Functions do not check _XmGetWidgetExtData() result).
* Fixed bug #1383 (missing semi-colon at end of sentense).
* Fixed bug #1390 (out of range in array read in ReplaceItem).
* Fixed bug #1388 (SEGV error moving mouse over window related 
  to XmToolTipGetLabel).
* Fixed bug #1387 (Scale Widget draws value text not centered to slider)
* Fixed bug #1381 (Sensitivity invisible with antialiased fonts)
* Fixed bug #1389 (A middle click on a tab lets nedit segfault)
* Fixed bug #1377 (XmText memory leak in InitializeHook)
* Fixed bug #1385 (core.self of XmMultiList is NULL, but must be 
  pointer itself.)
* Fixed bug #1380 (Can not set title bar in 2.3)

2.3.0 Beta 2 January 2006
* Fixed vulnerabilities in the libXpm code [CAN-2004-0914 
  (multiple vulnerabilities) and CAN-2005-0605 (buffer overflow)] 
* Got rid of the obsolete tmpnam() call in imake 
* Fixed bug #1315 (Division by zero in List widget) 
* Fixed bug #1314 (Buffer overflow in MrmItop.c on 64-bit systems) 
* Fixed bug #1313 (getsubres.c has fallback resources defined that
  aren't terminated with NULL) 
* Fixed bug #1304 (Buffer overflow in MrmOpenHierarchy...()) 
* Fixed bug #1297 (Insensitive XmPIXMAP XmPushButtons are stippled 
  with the wrong color) 
* Fixed bug #1294 (XmFileSelectionBox's XmNdirSpec resource misbehaves 
  when pathMode is PATH_MODE_RELATIVE) 

2.3.0 Beta 1 November 2005 
* #1121 (TabBox translation error) 
* Removed locking of the clipboard from XmClipboardRetrieveStart()
* #1283 (TabBox translation error)
* #1249 (XmCombo crashes program when resized)
* #1286 (XmDataField error with XmALIGNMENT_END)
* #1211 (Crash on setting XmNlabelPixmap in a ToggleButtonGadget)
* #1264 (Crash in PutDSToStream due to bug in _XmResizeHashTable)
* #1276 (Changing AddMode in XmList selects/deselects items without callback)
* #1196 (Free memory read in XmIm.c/draw_separator())
* #1193 (MWM crashes when restarting by a session manager)
* #1202 (MWM crashes when duplicating a window menu containing f.circle_up)
* #1186 (Invalid replacing XmList selected items)
* #1214 (Cannot set a string to XmTextField with XtSetValues when 
  XmNmodifyVerifyCallback is set)
* #1279 (XmTextGetSelectionPosition returns incorrect values after 
  deleting selection)
* #1269 (Popup menus fail on Tarantella/VNC)
* #1262 (Entering Esc key before pulldown menu realized crashes)
* #1268 (XmCvtXmStringToCT improperly handles an empty string)
* Added DataField.h and TabBox.h to XmAll.h
* Added synthetic resolution independent conversion of width/height resources 
  to ExtendedList for MultiList
* Added wide character string value of search string 
  to ExtendedListCallbackStruct
* Made DropDown using XmGrabShell instead of TopLevelShell
* #1260 (Option menu changes screen's focus to 'None')
* #1258 (XmDataField: data out-of-bounds bug in df_FindPixelLength)
* #1257 (XmTextField: "Character xxx not supported in font" errors, 
  bug in multibyte code)
* #1256 (Problem with XmNsingleSelectionCallback in XmExt18List widget)
* Fixed incorrect XmRenderTableToProp() behavior appearing in RendToProp test
* Fixed incorrect XmClipboardCopyByName() behavior appearing in CutPaste2 test

2.3.0 May 2007
a. Several bugs were fixed.

2.2.4 October 2004
a. Fixed vulnerabilities in libXpm code [CVE numbers CAN-2004-0687 
   (integer overflows) and CAN-2004-0688 (stack overflows)].
b. Fixed compilation under SUSE 9.1.
c. Fixed building procedure under FreeBSD.
d. Fixed building procedure in order to make it usable with 
   new versions of autoconfig.

2.2.3 August 2002
a. uil support for the new widgets was finished along with 
   demonstrations in the periodic demo.
b. Several bugs were fixed. 
c. Automake building is supported in an object directory. 

2.2.1 January 29, 2002
a. The Test directory that contained the automated tests was mentioned 
   in the Release Notes but absent from the source distribution. 
   The reference in the Release Notes was removed. The Tests are still 
   available from the CVS tree.
b. Due to an oversight, imake support was not included in the distribution. 
   It was added back in this update.
c. If an older version of Motif was installed, the Autoconf build would
   pick up the older #include files and fail. The Autoconf configuration 
   files were updated to use the proper #include files.
d. Formatting errors in doc/man/man3/Makefile.am were corrected.
e. The directory demos/unsupported/motifshell contained no source code but 
   was mentioned in configure.in. The proper source code was placed 
   in this directory.
f. ToolTip.c and SlideC.c were included in config.h twice. The extra 
   reference was removed.
g. The demos for the new widgets were originally placed in the directory 
   demos/programs/newwidgets. To maintain consistency, they were moved 
   to demos/programs.
h. The Releases Notes specified the incorrect resource names for enabling 
   tooltips and specifying the string. These typos were corrected. 
i. Compatibility note for user developed widgets was added to
   Release Notes.

2.2.0 January 28, 2002
Initial Release

